--have to duplicate this unfortunately, because it is local
local function best_weapon_of_type(available,types)

  local best_damage, best_weapon

--  print 'hi'

  for m,info in pairs(available)


    local d=info?.damage_fun?.average
      
    --print(m,info?.type, types[info?.type])

    if types[info?.type] and generic_less(best_damage, d)
      local specials = info.specials?
      if not (specials["Shield Damage Only"] or specials["EMP"])
        best_weapon=m
        best_damage=d
        --print(..m)
      end
    end

  end


  return best_weapon

end



local energy_weapon_types = set('beam','pd_kinetic','pd_beam','kinetic')
local bomber_weapon_types = set('missile')
local all_fighter_weapon_types = union(energy_weapon_types, bomber_weapon_types)

local function best_energy_weapon(available)
  return best_weapon_of_type(available, energy_weapon_types) or 'Laser'
end

local function best_bomber_weapon(available)
  return best_weapon_of_type(available, bomber_weapon_types) or 'Nuclear Missiles'
end

local function best_strike_weapon(available)
  return best_weapon_of_type(available, all_fighter_weapon_types) or 'Nuclear Missiles'
end

local fighter_weapon_fun = {
  energy = best_energy_weapon,
  bombs = best_bomber_weapon,
  strike = best_strike_weapon,
}

function _G.get_fighter_weapon(craft_type,empire,target) 

  local _TRACE_INFO = craft_type

  local type in empire.part_info![craft_type]!.loadout!

  local alt_type

  if (type == 'energy_or_bombs') 
    if target
      if is_tracking_object(target)
        type='energy'
      else
        type='strike'
      end
    else
      type='strike'
      alt_type='energy'
    end
  end

  local best_weapon = fighter_weapon_fun![type](empire:available_part_info()!)

  --print(..best_weapon)
  if alt_type
    return best_weapon,fighter_weapon_fun![alt_type](empire:available_part_info()!)
  end

  return best_weapon
end